#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

#ifndef ONLINE_JUDGE
const long MAX_TREES = 110;	//1100
#else
const long MAX_TREES = 1100;	//1100
#endif

const long MAX_TREE_HEIGHT = 25;

inline long Sqr(long x)
{
	return x*x;
}

inline long Max(long a, long b)
{
	return a>b?a:b;
}

inline long Min(long a, long b)
{
	return a<b?a:b;
}

long VectProd(long x1, long y1, long x2, long y2)
{
	return x1 * y2 - x2 * y1;
}

long Sgn(long x)
{
	if(x<0)return -1;
	if(x>0)return 1;
	return 0;
}

int Intersect(long bx, long by, long ex, long ey, long rx, long ry, long dir)
{
	static int retVal;
	static long vectProd;
	if(dir > 0)
	{
		vectProd = VectProd(ex - bx, ey - by, rx - bx, ry - by);
		if(!vectProd)retVal = 0;
		else retVal = (Sgn(vectProd)
			!= Sgn((ey - by) * dir));
    }
	else
	{
		vectProd = VectProd(bx - ex, by - ey, rx - ex, ry - ey);
		if(!vectProd)retVal = 0;
		else retVal = (Sgn(vectProd)
			!= Sgn((by - ey) * dir));
	}
	return retVal;
}

long Jump
(
	const long* leaves1,
	long height1,
	const long* leaves2,
	long height2,
	long distance,
	long maxJump
)
{
	static long leaf1, leaf2, check_leaf,
		leaf1x, leaf1y, leaf2x, leaf2y, min, max, jumpDist, resJump;
	static int ok;
	maxJump = Sqr(maxJump);
	resJump = 0;
	for(leaf1 = 0; leaf1 < height1; ++leaf1)
		for(leaf2 = 0; leaf2 < height2; ++leaf2)
		{
			if(!leaves1[leaf1]||!leaves2[leaf2])continue;
			leaf1x = leaves1[leaf1];
			leaf1y = leaf1;
			leaf2x = distance - leaves2[leaf2];
			leaf2y = leaf2;
			min = Min(leaf1, leaf2);
			max = Max(leaf1, leaf2);
			ok = 1;
			for(check_leaf = min + 1; check_leaf < max; ++check_leaf)
				if(Intersect
					(
						leaf1x, leaf1y, leaf2x, leaf2y,
						leaves1[check_leaf], check_leaf,
						1
					)
				)
				{
					ok=0;
					break;
				}
			if(!ok)continue;
			for(check_leaf = min + 1; check_leaf < max; ++check_leaf)
				if(Intersect
					(
						leaf1x, leaf1y, leaf2x, leaf2y,
						distance - leaves2[check_leaf], check_leaf,
						-1
					)
				)
				{
					ok=0;
					break;
				}
			if(!ok)continue;
			jumpDist = Sqr(leaf2x - leaf1x) + Sqr(leaf2y - leaf1y);
			if(jumpDist <= maxJump)
				if(resJump < leaf2x - leaf1x)
                	resJump = leaf2x - leaf1x;
		}
	return resJump;
}

long leaves[MAX_TREES][MAX_TREE_HEIGHT];
long treeHeights[MAX_TREES];

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long cTrees, distance, maxJump, cTests;
	scanf("%ld", &cTests);

	while(cTests--)
	{
		scanf("%ld %ld %ld", &cTrees, &distance, &maxJump);
		long height, tree, leaf;
		for(tree = 0; tree < cTrees; ++tree)
		{
			scanf("%ld", &treeHeights[tree]);
			for(leaf = 0; leaf < treeHeights[tree]; ++leaf)
				scanf("%ld", &leaves[tree][leaf]);
		}

		long jumpsSum = 0;
		for(tree = 1; tree < cTrees; ++tree)
			jumpsSum += Jump
			(
				leaves[tree-1],
				treeHeights[tree-1],
				leaves[tree],
				treeHeights[tree],
				distance,
				maxJump
			);
		printf("%ld\n", (cTrees - 1) * distance - jumpsSum);
	}


#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}